//HavokTest.h
#ifndef _HAVOKGIRLTEST_H
#define _HAVOKGIRLTEST_H

//#include <hkdemoframework/hkDefaultDemo.h>
#include <Demos/DemoCommon/DemoFramework/hkDefaultPhysicsDemo.h>
#include <Demos/DemoCommon/Utilities/Animation/AnimationUtils.h>

#include <Demos/Animation/Api/MotionExtraction/CharacterController/StateMachine/MyStateMachine.h>

// Vertex Deformation
#include <Animation/Animation/Deform/Skinning/hkaMeshBinding.h>

class hkpShapePhantom;
class hkpCharacterProxy;
class hkpCharacterContext;

class hkResource;
class hkLoader;
class hkaSkeleton;
class hkaAnimatedSkeleton;
class hkEaseControl;
class hkaPose;

class HavokGirlTest : public hkDefaultPhysicsDemo
{
	public:

		HK_DECLARE_CLASS_ALLOCATOR(HK_MEMORY_CLASS_DEMO);

		HavokGirlTest(hkDemoEnvironment* env);
		
		~HavokGirlTest();

		hkDemo::Result stepDemo();

	protected:

		// Simulation methods
		virtual void getStateMachineInput(MyStateMachineInput& input) const;
		virtual void stepWorldAndController(const MyStateMachineOutput& output);
		
		// Displays the current state in the screen
		virtual void displayCurrentState() const;

		// Updates the camera 
		virtual void updateCamera(const MyStateMachineOutput& output) const;

		// Gets the pose from the girl, based on controller position
		virtual void getCharacterPose (const MyStateMachineOutput& output, hkaPose& poseOut) const;

		// Renders a pose of the girl
		virtual void renderPose (const hkaPose& pose) const;
		
		// Z is up
		const hkVector4 m_up;

		// Loaded data
		hkLoader* m_loader; // Animation

		hkArray< hkRefPtr<hkaMeshBinding> > m_skinBindings;

		/*
		** Character Controller stuff
		*/
		hkpShapePhantom* m_phantom;
		hkpShape* m_standShape;

		// The context for this character in the animation state machine
		MyStateMachineContext m_characterContext;

		// The state machine that govers the animation of the character
		MyStateMachine* m_stateMachine;

		hkBool m_forcedOnTrackball;

};

#endif // _HAVOKGIRLTEST_H
